' allow extended keys like CTRL+a

enum ExtendControl
  none = 0, ctrl = 1, shift = 2, alt = 4
end enum

type TExtendKey
  dim as integer control, ascii
  dim as string  value
  declare constructor
  declare constructor(c as integer, a as integer, v as string)
  declare operator cast as string
end type
constructor TExtendKey
end constructor
constructor TExtendKey(c as integer, a as integer, v as string)
  control = c
  ascii   = a
  value   = v
end constructor
operator TExtendKey.cast as string
  return chr(control, ascii) & value
end operator
operator =(k1 as TExtendKey, k2 as TExtendKey) as integer
  return k1.control = k2.control and k1.ascii = k2.ascii
end operator

function checkCtrlAltShift(value as integer) as integer
  ' does 'value' contain the right key state?
  if (value and ExtendControl.ctrl) = 0 xor multikey(FB.SC_CONTROL) = 0 then return 0
  if (value and ExtendControl.alt) = 0 xor multikey(FB.SC_ALT) = 0 then return 0
  if (value and ExtendControl.shift) = 0 _
            xor (multikey(FB.SC_LSHIFT) = 0 and multikey(FB.SC_RSHIFT) = 0) then return 0
  return -1
end function

mdListDeclare(TExtendKey)
dim shared as mdList(TExtendKey) globalKeyList

scope
  dim as string txt, value
  dim as integer srch, control = ExtendControl.none, filenumber = freefile

#ifdef __FB_PCOS__
  if open(MODULE_PATH & "keyboard_windows.txt" for input as #filenumber) = 0 then
#else
  if open(MODULE_PATH & "keyboard_linux.txt" for input as #filenumber) = 0 then
#endif
    do until eof(filenumber)
      line input #filenumber, txt
      txt = trim(txt, any chr(9, 32))
      if len(txt) = 0 orelse txt[0] = 35 then continue do
      select case ucase(txt)
        case "[SHIFT]"
          control = ExtendControl.shift
        case "[CTRL]"
          control = ExtendControl.ctrl
        case "[CTRL+SHIFT]"
          control = ExtendControl.ctrl + ExtendControl.shift
        case "[ALT]"
          control = ExtendControl.alt
        case "[ALT+SHIFT]"
          control = ExtendControl.alt + ExtendControl.shift
        case "[ALT+CTRL]"
          control = ExtendControl.alt + ExtendControl.ctrl
        case "[ALT+CTRL+SHIFT]"
          control = ExtendControl.alt + ExtendControl.ctrl + ExtendControl.shift
        case else
          srch = instr(txt, " ")
          if srch then 
            globalKeyList.add TExtendKey(control, val(txt), trim(mid(txt, srch)))
          end if
      end select
    loop
    close #filenumber
  end if
end scope
