#include once "mdList.bi"
#include once "mdMap.bi"

mdListDeclare(TWString)
mdMapDeclare(string, TWString)

type TWord
  as long id, lession, lessionPos, mark, levelA, levelB, countA, countB
  as string groupname
  as TWString word
  as mdList(TWString) translate, tag
  as mdMap(string, TWString) map
  declare constructor
  declare constructor(w as string, t as string, g as string = "")
  declare constructor(init as string)
  declare operator cast as string
  declare sub clear
end type

constructor TWord
end constructor

constructor TWord(w as string, t as string, g as string = "")
  word = w
  translate.add(t)
  groupname = g
end constructor

constructor TWord(init as string)
  if len(init) < 18 then exit constructor
  lession = cvl(left(init, 4))
  dim as integer transSize = cvl(mid(init,  5, 4))
  dim as integer tagSize   = cvl(mid(init,  9, 4))
  dim as integer mapSize   = cvl(mid(init, 13, 4))
  dim as integer groupSize = init[16]
  dim as integer wordSize  = init[17]
  dim as integer position  = 19, size
  dim as string key
  groupname = mid(init, position, groupSize) : position += groupSize
  word      = mid(init, position, wordSize)  : position += wordSize
  for i as integer = 1 to transSize
    if position >= len(init) then exit constructor
    size = init[position-1]
    translate.add(mid(init, position+1, size))
    position += size+1
  next
  for i as integer = 1 to tagSize
    if position >= len(init) then exit constructor
    size = init[position-1]
    tag.add(mid(init, position+1, size))
    position += size+1
  next
  for i as integer = 1 to mapSize
    if position >= len(init) then exit constructor
    size = init[position-1]
    key = mid(init, position+1, size)
    position += size+1
    if position >= len(init) then exit constructor
    size = init[position-1]
    map.put(key, mid(init, position+1, size))
    position += size+1
  next
end constructor

operator =(w1 as TWord, w2 as TWord) as integer
  if w1.id = w2.id then return -1
end operator

operator <>(w1 as TWord, w2 as TWord) as integer
  return not (w1 = w2)
end operator

operator TWord.cast as string
  dim as TWString tw
  dim as string tempString, s, NL = chr(13, 10)
  dim as string ret = "ENTRY " & id & NL & "pos   " & (lession*1000 + lessionPos) & NL _
                    & "word  " & word & NL & "group " & groupname & NL
  dim as mdSet(string) ks = map.keyset
  foreach(TWString, tw, tag)
    ret &= "tag " & str(tw) & NL
  nexteach
  foreach(string, s, ks)
    if s <> "" then
      tempString = map.get(s)
      ret &= s & " " & tempString & NL
    end if
  nexteach
  if mark > 0 then ret &= "mark  " & mark & NL
  foreach(TWString, tw, translate)
    ret &= "trans " & str(tw) & NL
  nexteach
  return ret
end operator

sub TWord.clear
  id        = 0
  lession   = 0
  mark      = 0
  groupname = ""
  word      = ""
  translate.clear
  tag.clear
  map.clear
end sub

mdListDeclare(TWord)
