' module: list choosen words and their translation
#include once "include/showWords.bi"

namespace LEARNING
  declare function callback(exercise as TExercise) as long
  declare sub drawAll(list as mdList(TListPoint), allPages as TPages, page as integer, gui as TGui)
  declare function outpt(x as integer, y as integer, x2 as integer, h as integer, _
                         word as TWord, opt as integer) as integer
  declare function settings(exercise as TExercise, optional as long = SETTING_OPTIONS.NONE) as long
end namespace

globalExercises.add(TExercise("learn", localize("learningTitle"), "full", 0, @LEARNING.callback, 0, @LEARNING.settings))

function LEARNING.callback(exercise as TExercise) as long
  dim as integer index, count, mx, my, mb, mw, wheel, upState, downState
  dim as integer tempInt, page = 0
  dim as uinteger col
  static as integer spec = 1
  dim as string tempstring, key, hideTxt(2) = { lcase(LANGTITLE1) & " -> " & lcase(LANGTITLE2), _
                                                lcase(LANGTITLE2) & " -> " & lcase(LANGTITLE1), _
                                                localize("showAll") }
  dim as mdList(TListPoint) list
  if exercise.currentList.size then
    list.addAll(exercise.currentList.list)
    count = exercise.currentlist.size
  else
    list.addAll(exercise.fullList.list)
    count = exercise.fulllist.size
    if count = 0 then
      message(localize("noWords"))
      return RETVAR.emptyList
    end if
  end if
  dim as TWord word

  enum
    posNone = 0, posSetting, posHelp, posHide, posShuffle, posBack, posUp, posDown
  end enum
  dim as integer LBx = 100, LBy = 590, LBw = 150, LBh = 30, LBp = 20
  dim learnGui as TGui, event as TGuiEvent
  learnGui.addElement _
      TGuiElement(GuiElementType.button, posHide, LBx+LBw+LBp, LBy, LBw, LBh, hideTxt(spec), chr(255, 61))
  learnGui.addElement _
      TGuiElement(GuiElementType.button, posShuffle, LBx+2*(LBw+LBp), LBy, LBw, LBh, localize("mixWords"), chr(255, 62))
  learnGui.addElement _
      TGuiElement(GuiElementType.button, posBack, LBx+3*(LBw+LBp), LBy, LBw, LBh, localize("back"), chr(27))
  learnGui.addElement _
      TGuiElement(GuiElementType.button, posHelp, _
                  exepath & "/img/help.bmp", LBx+50, LBy, 40, 40, chr(255, 59),, "", GuiState.noBorder)
  learnGui.addElement _
      TGuiElement(GuiElementType.button, posSetting, _
                  exepath & "/img/settings.bmp", LBx+100, LBy, 40, 40, chr(9),, "", GuiState.noBorder)
  learnGui.addElement _
      TGuiElement(GuiElementType.button, posUp, _
                  exepath & "/img/up.bmp", LBx-60, LBy, 31, 30, chr(255, 73))
  learnGui.addElement _
      TGuiElement(GuiElementType.button, posDown, _
                  exepath & "/img/down.bmp", LBx-20, LBy, 31, 30, chr(255, 81))

  ' show words
  dim as TPages pages = TPages(13, 40, 15, 15, 10, 180, 550, 390, 2)
  pages.outp = @outpt
  pages.barState = spec
  pages.calcPositions(list)
  page = 0
  do
    pages.barPos = 0
    screenlock
    cls
    line (0, 0)-step(SCREEN_X-1, LBy-1), &hffffff, bf
    pages.printEntries(list, page)
    ' show arrow buttons or not?
    if pages.pages.size = 1 then
      ' hide if only one page is shown
      if upState <> GuiState.hidden then
        dim as TGuiElement tempButton = learnGui.getElement(posUp)
        tempButton.state = GuiState.hidden
        learnGui.setElement(tempButton)
        upstate = GuiState.hidden
      end if
      if downState <> GuiState.hidden then
        dim as TGuiElement tempButton = learnGui.getElement(posDown)
        tempButton.state = GuiState.hidden
        learnGui.setElement(tempButton)
        downState = GuiState.hidden
      end if
    else
      if page = 0 then
        ' deactivate "up"
        if upState <> GuiState.deactivated then
          dim as TGuiElement tempButton = learnGui.getElement(posUp)
          tempButton.state = GuiState.deactivated
          learnGui.setElement(tempButton)
          upState = GuiState.deactivated
        end if
      else
        ' activate "up"
        if upState <> GuiState.active then
          dim as TGuiElement tempButton = learnGui.getElement(posUp)
          tempButton.state = GuiState.active
          learnGui.setElement(tempButton)
          upState = GuiState.active
        end if
      end if
      if page = pages.pages.size-1 then
        ' deactivate "down"
        if downState <> GuiState.deactivated then
          dim as TGuiElement tempButton = learnGui.getElement(posDown)
          tempButton.state = GuiState.deactivated
          learnGui.setElement(tempButton)
          downState = GuiState.deactivated
        end if
      else
        ' activate "down"
        if downState <> GuiState.active then
          dim as TGuiElement tempButton = learnGui.getElement(posDown)
          tempButton.state = GuiState.active
          learnGui.setElement(tempButton)
          downState = GuiState.active
        end if
      end if
    end if
    learnGui.show
    pages.showBar
    screenunlock
    do
      getmouse mx, my, wheel, mb
      sleep 1
    loop until mb < 1
    ' user input
    do
      key = inkey
      event = learnGui.getEvent(key)
      ' mouse wheel / cursor
      if getmouse(mx, my, mw, mb) then mb = 0 : mw = wheel
      if mw > wheel or key = chr(255, 72) then
        wheel = mw
        pages.moveBar -1
        drawAll list, pages, page, learnGui
      elseif mw < wheel or key = chr(255, 80) then
        wheel = mw
        pages.moveBar 1
        drawAll list, pages, page, learnGui
      end if
      ' mark / speak words / show more info
      tempInt = iif(key = "0", -1, cint(key))
      if tempInt = 9 then tempInt = 0
      if tempInt orelse mb = 1 orelse mb = 2 then
        for i as integer = 0 to ubound(pages.wordPos)
          with pages.wordPos(i)
            if checkMouseIn(.x, .y-pages.wordDist\2, pages.colDist\2, .h+pages.wordDist) <> 0 then
              if tempInt then
                ' mark word
                word = globallist.get(.id)
                word.mark = iif(tempInt = -1 or word.mark = tempInt, 0, tempInt)
                globallist.put(.id, word)
                screenlock
                cls
                pages.printEntries(list, page)
                pages.showBar
                learnGui.show
                screenunlock
              elseif mb = 2 then
                ' speak word
                if pages.barState <> 2 orelse i < pages.barPos then
                  speakThread globallist.get(.id).word
                  exit for
                end if
              elseif mb = 1 then
                ' show info
                if pages.barState <> 2 orelse i < pages.barPos then
                  dim as FB.Image ptr tempImg = imagecreate(SCREEN_X, SCREEN_Y)
                  get (0, 0)-(SCREEN_X-1, SCREEN_Y-1), tempImg
                  wordInfo globallist.get(.id)
                  put (0, 0), tempImg, pset
                  imagedestroy tempImg
                  exit for
                end if
              end if
            end if
          end with
        next
        do
          getmouse mx, my, wheel, mb
          sleep 1
        loop until mb < 1
      end if
      ' GUI buttons
      select case event.id
        case posUp
          if page > 0 then
            page -= 1
            exit do
          end if
        case posDown
          if page < pages.pages.size-1 then
            page += 1
            exit do
          end if
        case posHelp
          dim as integer ret = showHelpScreen(MODULE_PATH & "doc.htm", "learning")
          if ret = RETVAR.windowClosed then key = chr(255, 107)
        case posSetting
          tempInt = settings(exercise)
          list.clear
          if exercise.currentList.size then
            list.addAll(exercise.currentList.list)
            count = exercise.currentlist.size
          else
            list.addAll(exercise.fullList.list)
            count = exercise.fulllist.size
          end if
          pages.calcPositions(list)
          page = 0
          if tempInt = RETVAR.windowClosed then key = chr(255, 107)
          exit do
        case posHide
          spec = (spec+1) mod 3
          pages.barState = spec
          drawAll list, pages, page, learnGui
          dim as TGuiElement tempButton = learnGui.getElement(posHide)
          tempButton.title = hideTxt(spec)
          learnGui.setElement(tempButton)
          tempButton.show
          exit do
        case posShuffle
          for i as integer = count-1 to 0 step -1
            index = int(rnd*(i+1))
            list.add(list.get(index))
            list.remove(index)
          next
          pages.calcPositions(list)
          page = 0
          exit do
        case posBack
          exit do, do
      end select
      sleep 1
    loop until key = chr(255, 107)
  loop until key = chr(27) or key = chr(255, 107)
  if key = chr(255, 107) then return RETVAR.windowClosed
  return RETVAR.ok
end function

sub LEARNING.drawAll(list as mdList(TListPoint), allPages as TPages, page as integer, gui as TGui)
  screenlock
  cls
  allPages.printEntries(list, page)
  allPages.showBar
  gui.show
  screenunlock
end sub

function LEARNING.outpt(x as integer, y as integer, x2 as integer, h as integer, _
                        word as TWord, opt as integer) as integer
  dim as uinteger col, ret = word.translate.size, img
  dim as string extraLine
  dim as TWord outWord = prettyOutput(word, PRETTOUT.ARTICLE, col, extraLine, img)
  if len(extraLine) and ret = 1 then ret = 2
  if opt mod 32 then
    printFT x, y, outWord.word, font, opt mod 32, col,, -1
    if len(extraLine) then printFT x, y+15, extraLine, font, opt mod 32
    select case img
      case ImageType.alert
        dim as FB.Image ptr attImg = imagecreate(16, 16)
        bload exepath & "/img/attention.bmp", attImg
        put (x-14, y), attImg, pset
        imagedestroy attImg
      case ImageType.check
        dim as FB.Image ptr attImg = imagecreate(16, 16)
        bload exepath & "/img/ok.bmp", attImg
        put (x-14, y), attImg, pset
        imagedestroy attImg
    end select
    for i as integer = 0 to outWord.translate.size-1
      printFT x2, y+i*15, outWord.translate.get(i), font, opt mod 32
    next
    if word.mark > 0 then
      dim as FB.Image ptr markImg
      markImg = imagecreate(16, 16)
      bload exepath & "/img/" & word.mark & ".bmp", markImg
      put (x-30, y), markImg, pset
      imagedestroy markImg
    end if
  end if
  return ret*h
end function

function LEARNING.settings(exercise as TExercise, optional as long = SETTING_OPTIONS.NONE) as long
  return chooseWords(exercise, exercise.settingString, optional or SETTING_OPTIONS.SHOWTAGS)
end function
