' specific defines for common modules

' functions and defines for global exercises
enum ImageType
  none = 0, alert, check
end enum
namespace PRETTOUT
  const NONE = 0, HINT1 = 1, HINT2 = 2, OBJ = 4, ARTICLE = 8, BOTHGEN = 16, STRESS = 32
  const FULL = ARTICLE or BOTHGEN
end namespace

declare function flexionLang1(w as TWord, inflection as integer) as TWord
declare function flexionLang2(w as TWord, inflection as integer, no as integer = 0) as string
declare function prettyOutput(w as TWord, setting as integer, byref col as uinteger = 0, _
                              byref extraLine as string = "", byref img as ImageType = ImageType.none) as TWord

const MAX_WORDLENGTH = 35
const MODIFY_SEARCH_SIMPLE       = MODIFY_TOLOWER or MODIFY_NOUMLAUT
dim shared as TWString SPECIAL_KEYS = "àèéìíïòóùúäöüßÀÈÉÌÍÏÒÓÙÚÄÖÜ"
dim shared as TWString SIMPLE_UPPER = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
dim shared as TWString EXTEND_UPPER = SIMPLE_UPPER
dim shared as TWString FULL_UPPER   = EXTEND_UPPER & "ÀÈÉÌÍÏÒÓÚÙ"

type crosswordData
  as uinteger keyboardHeight, posKeys
  as TWString keys
  as boolean showDefault
end type

function flexionLang1(w as TWord, inflection as integer) as TWord
  select case w.groupname
    case "verb"
      return conjugItalian(w, inflection)
    case "noun", "adjective"
      return declinItalian(w, inflection)
    case else
      return w
  end select
end function

function flexionLang2(w as TWord, inflection as integer, no as integer = 0) as string
  select case w.groupname
    case "verb"
      return conjugGerman(w, inflection, no)
    case "noun", "adjective"
      return declinGerman(w, inflection, no)
    case else
      return w.translate.get(no)
  end select
end function

function prettyOutput(w as TWord, setting as integer, byref col as uinteger = 0, _
                      byref extraLine as string = "", byref img as ImageType = ImageType.none) as TWord
  dim as TWord ret
  col = rgb(0, 0, 0)
  dim as string tempString
  if w.groupname = "noun" then
    tempString = getArticle(w) & w.word 
    select case str(w.map.get("genus"))
      case "f"
        col = rgb(255, 0, 0)
      case "m"
        col = rgb(0, 0, 255)
      case else
        col = 0
    end select
  end if
  if setting and PRETTOUT.ARTICLE then
    ret.word = getArticle(w, -1) & w.word
  else
    ret.word = w.word
  end if
  if setting and PRETTOUT.HINT1 then
    tempString = w.map.get("hint-it")
    if len(tempString) then ret.word &= " (" & tempString & ")"
  end if
  if setting and PRETTOUT.HINT2 then
    tempString = w.map.get("hint-de")
    ret.translate.add w.translate.get(0) & iif(len(tempString), " (" & tempString & ")", "")
  else
    ret.translate.add w.translate.get(0)
  end if
  for i as integer = 1 to w.translate.size - 1
    ret.translate.add w.translate.get(i)
  next
  if len(w.map.get("irr")) then img = IMAGETYPE.ALERT
  return ret
end function
