' module: list choosen words and their translation
#include once "include/showWords.bi"
#include once "vbcompat.bi"
#include once "quehora.bi"
#include once "trainconj.bi"

namespace GRAMMAR
  declare function callback(exercise as TExercise) as long
  declare function info(exercise as TExercise) as string
end namespace

globalExercises.add(TExercise("grammar", "Grammatik-Übungen", "full", 0, _
                    @GRAMMAR.callback, @GRAMMAR.info, 0))

function GRAMMAR.callback(exercise as TExercise) as long
  ' overview over the grammar exercices
  dim as integer mx, my, mb
  dim as string key, settingID, settingString
  dim as TGuiEvent event

  dim as string headline = "Grammatik-Übungen"
  dim as TExercise grammarList(...) = { _
         TExercise("quehora", "¿Que hora es?", "full", 0, @QUEHORA.callback, 0, 0), _
         TExercise("trainconj", "Konjugations-Trainer", "trainconj", 0, @TRAINCONJ.callback, 0, @TRAINCONJ.settings) }

  ' read settings
  dim as integer count = 1, size
  do until count > len(exercise.settingString)
    size = cvl(mid(exercise.settingString, count, 4))
    if size+count+3 > len(exercise.settingString) then exit do
    settingID = mid(exercise.settingString, count+4, size)
    count += size+4
    size = cvl(mid(exercise.settingString, count, 4))
    if size+count+3 > len(exercise.settingString) then exit do
    settingString = mid(exercise.settingString, count+4, size)
    count += size+4
    for ex as integer = 0 to ubound(grammarList)
      if grammarList(ex).id = settingID then grammarList(ex).settingString = settingString
    next
  loop

  dim as TGui grammarGui
  dim as TGuiButton grammarButton(0 to ubound(grammarList)), grammarOption(0 to ubound(grammarList))
  for ex as integer = 0 to ubound(grammarList)
    grammarList(ex).fullList = TList(grammarList(ex).listname)
    grammarList(ex).fullList.load
    grammarButton(ex) = TGuiButton(ex+1, 150, 150+50*ex, 150, 30, grammarList(ex).title)
    grammarGui.buttons.add grammarButton(ex)
    if grammarList(ex).settings then
      grammarList(ex).settings(grammarList(ex), SETTING_OPTIONS.SKIPDIALOG)
      grammarOption(ex) = TGuiButton(ex+101, exepath & "/img/settings.bmp", 320, 150+50*ex, 30, 30)
      grammarGui.buttons.add grammarOption(ex)
    end if
  next
  grammarGui.buttons.add TGuiButton(999, 150, 150+50*(ubound(grammarList)+1.5), 150, 30, "zurück", chr(27))
  screenlock
  cls
  centerFT SCREEN_X\2, 50, headline, font, 20
  grammarGui.show
  screenunlock

  do
    getmouse mx, my,, mb
    sleep 1
  loop until mb < 1
  do
    key = inkey
    if key = chr(255, 107) then exit do
    event = grammarGui.getEvent(key)
    select case event.id
      case 1 to ubound(grammarList)+1
        if grammarList(event.id-1).callback(grammarList(event.id-1)) = RETVAR.windowClosed then
          return RETVAR.windowClosed
        end if
        screenlock
        cls
        centerFT SCREEN_X\2, 50, headline, font, 20
        grammarGui.show
        screenunlock
      case 101 to ubound(grammarList)+101
        if grammarList(event.id-101).settings(grammarList(event.id-101), SETTING_OPTIONS.NONE) = RETVAR.windowClosed then
          return RETVAR.windowClosed
        end if
        screenlock
        cls
        centerFT SCREEN_X\2, 50, headline, font, 20
        grammarGui.show
        screenunlock
      case 999
        exit do
    end select
    sleep 1
  loop

  ' save settings
  exercise.settingString = ""
  for ex as integer = 0 to ubound(grammarList)
    exercise.settingString &= mkl(len(grammarList(ex).id)) & grammarList(ex).id _
                            & mkl(len(grammarList(ex).settingString)) & grammarList(ex).settingString
  next

  if key = chr(255, 107) then return RETVAR.windowClosed
  return RETVAR.ok
end function

function GRAMMAR.info(exercise as TExercise) as string
  return ""
end function
